<template>
  <div class="sw-gs-gallery-big sf-gallery">
    <div class="sf-gallery__stage">
      <div ref="glide" class="glide">
        <div class="glide__track" data-glide-el="track">
          <ul class="glide__slides">
            <li v-for="(picture, index) in images"
                :key="'slide-' + index"
                class="glide__slide sw-gallery-item"
                :style="{ minHeight: imageMinHeight ? imageMinHeight : 'none' }">
              <SwImage ref="sfGalleryBigImage"
                       class="sf-gallery__big-image"
                       :class="imageDisplayClass"
                       :src="picture.desktop.url"
                       :alt="picture.alt"
                       :width="imageWidth"
                       :height="imageHeight"
                       :style="{ minHeight: imageMinHeight ? imageMinHeight : 'none' }"
                       @click="$emit('click:stage', { picture, index })"/>
            </li>
          </ul>
        </div>

        <div class="sw-gs-gallery-big-controls" data-glide-el="controls">
          <SwButton v-if="images.length > 1" class="sw-gs-gallery-big-control-prev color-light" data-glide-dir="<">
            <SwGsIconLongArrowLeft class="dark-secondary size-sm"/>
          </SwButton>

          <SwButton v-if="images.length > 1" class="sw-gs-gallery-big-control-next color-light" data-glide-dir=">">
            <SwGsIconLongArrowRight class="dark-secondary size-sm"/>
          </SwButton>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
  import { computed } from "@vue/composition-api";
  import Glide from "@glidejs/glide";
  import { Controls } from '@glidejs/glide/dist/glide.modular.esm';
  import SwButton from "@/components/atoms/SwButton.vue";
  import SwImage from "@/components/atoms/SwImage.vue";
  import { SwGsIconLongArrowLeft, SwGsIconLongArrowRight } from "./icons";

  export default {
    name: "SwGsGalleryBig",
    components: {
      SwButton,
      SwImage,
      SwGsIconLongArrowLeft,
      SwGsIconLongArrowRight
    },
    props: {
      configuration: {
        type: Object,
        default: () => ({}),
      },
      /**
       * Images list
       */
      images: {
        type: Array,
        default: () => [],
      },
      /**
       * Images width, without unit
       */
      imageWidth: {
        type: [Number, String],
        default: 700,
      },
      /**
       * Images height, without unit
       */
      imageHeight: {
        type: [Number, String],
        default: 700,
      },
      /**
       * Initial image number (starting from 1)
       */
      current: {
        type: Number,
        default: 1,
      },
      /**
       * Glide slider options (https://glidejs.com/docs/options/)
       */
      sliderOptions: {
        type: Object,
        default() {
          return {
            type: "slider",
            autoplay: false,
            rewind: true,
            perView: 3,
            peek: {
              before: 0,
              after: 200,
            },
            breakpoints: {
              1199: {
                perView: 2,
                peek: {
                  before: 0,
                  after: 100,
                },
              },
              991: {
                perView: 2,
                peek: {
                  before: 0,
                  after: 100,
                },
              },
              767: {
                perView: 1,
                peek: {
                  before: 0,
                  after: 200,
                },
              },
              575: {
                perView: 1,
                peek: 0,
              },
            }
          };
        },
      },
    },
    data() {
      return {
        positionStatic: {},
        eventHover: {},
        pictureSelected: "",
        glide: null,
        activeIndex: this.current - 1,
        style: "",
      };
    },
    computed: {
      mapPictures() {
        // map images to handle picture tags with SwImage
        return this.images.map(({ desktop, big }) => ({
          mobile: desktop,
          desktop: big,
        }));
      },
      updatedSliderOptions() {
        const maxImages = this.images.length;
        return {
          ...this.sliderOptions,
          startAt: this.activeIndex,
          perView: maxImages < 3 ? maxImages : 3,
          breakpoints: {
            991: {
              perView: maxImages < 2 ? maxImages : 2,
              peek: {
                before: 0,
                after: 100,
              },
            },
            767: {
              perView: 1,
              peek: {
                before: 0,
                after: 200,
              },
            },
            575: {
              perView: 1,
              peek: 0,
            },
          }
        }
      }
    },
    setup(props) {
      const config = props?.configuration;
      const displayMode = config.displayMode?.value;

      const imageDisplayClass = computed(
        () => displayMode ? 'is-' + displayMode : 'is-standard'
      );
      const imageMinHeight = (config.minHeight.value && (displayMode === "cover" || displayMode === "contain")) ? config.minHeight.value : '';

      return {
        imageDisplayClass,
        imageMinHeight
      }
    },
    mounted() {
      this.$nextTick(() => {
        // handle slider with swipe and transitions with Glide.js
        // https://glidejs.com/docs/
        if (this.images.length < 1) return;
        const glide = new Glide(this.$refs.glide, this.updatedSliderOptions);
        glide.on("run", () => {
          this.go(glide.index);
        });
        glide.mount({ Controls });
        this.glide = glide;
        this.$refs.glide.glide = this.glide;
      });
    },
    beforeDestroy() {
      if (this.glide) {
        this.glide.destroy();
      }
    },
    methods: {
      go(index) {
        if (!this.glide) return;
        this.activeIndex = index;
        /**
         * Event for current image change (`v-model`)
         * @type {Event}
         */
        this.$emit("click", index + 1);
        if (this.glide) {
          this.glide.go(`=${index}`);
        }
      },
    },
  };
</script>
<style lang="scss">
  @import "~@storefront-ui/shared/styles/components/molecules/SfGallery.scss";
  @import "@/assets/scss/variables";

  .sw-gs-gallery-big {
    .sw-gallery-item {
      position: relative;
    }

    .sf-image--wrapper {
      &.is-standard {
        .sf-image {
          object-fit: initial;
          height: auto;
          width: auto;
        }
      }

      &.is-cover,
      &.is-contain {
        position: absolute;
        top: 0;
        right: 0;
        bottom: 0;
        left: 0;
        height: 100%;

        .sf-image {
          position: absolute;
          top: 0;
          right: 0;
          bottom: 0;
          left: 0;
          height: 100%;
        }
      }

      &.is-cover {
        object-fit: cover;

        .sf-image {
          object-fit: cover;
        }
      }

      &.is-contain {
        object-fit: contain;

        .sf-image {
          object-fit: contain;
          margin: auto;
        }
      }
    }

    .sf-image--wrapper,
    .sf-image {
      max-width: 100%; // prevent overflow
    }
  }

  .sw-gs-gallery-big-control-prev,
  .sw-gs-gallery-big-control-next {
    border-radius: 50%;
    max-width: 20px;
    padding: 14px 25px;
    position: absolute;
    top: 50%;
    transform: translateY(-50%);

    @include for-tablet {
      padding: 22px 32px;
    }
  }

  .sw-gs-gallery-big-control-prev {
    left: 15px;
  }

  .sw-gs-gallery-big-control-next {
    right: 15px;
  }
</style>
